// ICFRanger.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ICFRanger.h"
#include "ICFRangerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CICFRangerApp

BEGIN_MESSAGE_MAP(CICFRangerApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CICFRangerApp construction

CICFRangerApp::CICFRangerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CICFRangerApp object

CICFRangerApp theApp;


// CICFRangerApp initialization

BOOL CICFRangerApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	CoInitialize(NULL);
	CoInitializeSecurity(NULL, -1, NULL, NULL, RPC_C_AUTHN_LEVEL_PKT,
							RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE, NULL);

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
//	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	INetSharingManager * pNSM = NULL;    
	if (FAILED(CoCreateInstance(__uuidof(NetSharingManager), NULL, CLSCTX_ALL,
								__uuidof(INetSharingManager), (void**)&pNSM))
	||	NULL == pNSM)
	{
		AfxMessageBox(L"Failed to create Net Configuration object", MB_OK|MB_ICONERROR);
	}
	else
	{
		INetSharingEveryConnectionCollection * pNSECC = NULL;
		if (FAILED(pNSM->get_EnumEveryConnection(&pNSECC))
		||	NULL == pNSECC)
		{
			AfxMessageBox(L"Failed to list network connections", MB_OK|MB_ICONERROR);
		}
		else
		{
			std::vector< std::pair< NETCON_PROPERTIES *, INetSharingConfiguration * > > suitableConnections;

			IEnumVARIANT * pEV = NULL;
			IUnknown * pUnk = NULL;
			if (SUCCEEDED(pNSECC->get__NewEnum(&pUnk)) && NULL != pUnk)
			{
				if (SUCCEEDED(pUnk->QueryInterface(__uuidof(IEnumVARIANT), (void**)&pEV)) && NULL != pEV)
				{
					VARIANT v;
					VariantInit(&v);

					while (S_OK == pEV->Next(1, &v, NULL))
					{
						INetConnection * pNC = NULL;

						if (V_VT(&v) == VT_UNKNOWN
						&&	SUCCEEDED(V_UNKNOWN(&v)->QueryInterface(__uuidof(INetConnection), (void**)&pNC)) && NULL != pNC)
						{
							NETCON_PROPERTIES *pProps = NULL;

							if (SUCCEEDED(pNC->GetProperties(&pProps)) && NULL != pProps)
							{
								if ((pProps->dwCharacter & (NCCF_SHARED | NCCF_FIREWALLED))
								&&	pProps->MediaType != NCM_SHAREDACCESSHOST_LAN
								&&	pProps->MediaType != NCM_SHAREDACCESSHOST_RAS)
								{
									INetSharingConfiguration * pNSC = NULL;
									if (SUCCEEDED(pNSM->get_INetSharingConfigurationForINetConnection(pNC, &pNSC)) && NULL != pNSC)
									{
										suitableConnections.push_back( std::make_pair( pProps, pNSC ) );

										pProps = NULL;
									}
								}

								if (NULL != pProps)
								{
									//NcFreeNetconProperties(pProps);
								}
							}
							pNC->Release();
						}
						VariantClear(&v);
					}
					pEV->Release();
				}
				pUnk->Release();
			}

			if (suitableConnections.empty())
			{
				AfxMessageBox(L"Found no suitable network connections with ICF enabled", MB_OK|MB_ICONWARNING);
			}
			else
			{
				CICFRangerDlg dlg;
				m_pMainWnd = &dlg;
				dlg.m_pConnections = &suitableConnections;
				INT_PTR nResponse = dlg.DoModal();

				while(!suitableConnections.empty())
				{
					//NcFreeNetconProperties(suitableConnections.back().first);
					suitableConnections.back().second->Release();
					suitableConnections.pop_back();
				}
			}

			pNSECC->Release();
		}

		pNSM->Release();
	}

	CoUninitialize();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
