// ICFRangerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ICFRanger.h"
#include "ICFRangerDlg.h"
#include ".\icfrangerdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CICFRangerDlg dialog



CICFRangerDlg::CICFRangerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CICFRangerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CICFRangerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CONNECTIONS, m_ctrlListConnections);
	DDX_Control(pDX, IDC_EDIT_DESCRIPTION, m_ctrlEditDescription);
	DDX_Control(pDX, IDC_EDIT_COMPUTER, m_ctrlEditComputer);
	DDX_Control(pDX, IDC_EDIT_EXT_START, m_ctrlEditExtStart);
	DDX_Control(pDX, IDC_EDIT_EXT_END, m_ctrlEditExtEnd);
	DDX_Control(pDX, IDC_EDIT_INT_START, m_ctrlEditIntStart);
	DDX_Control(pDX, IDC_EDIT_INT_END, m_ctrlEditIntEnd);
	DDX_Control(pDX, IDC_RADIO_TCP, m_ctrlRadioButtonTCP);
	DDX_Control(pDX, IDC_RADIO_UDP, m_ctrlRadioButtonUDP);
	DDX_Control(pDX, IDC_PROGRESS_ADDING, m_ctrlProgressAdding);
}

BEGIN_MESSAGE_MAP(CICFRangerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_EN_CHANGE(IDC_EDIT_EXT_START, OnEnChangeEditExtStart)
	ON_EN_CHANGE(IDC_EDIT_EXT_END, OnEnChangeEditExtEnd)
	ON_EN_CHANGE(IDC_EDIT_INT_START, OnEnChangeEditIntStart)
END_MESSAGE_MAP()


// CICFRangerDlg message handlers

BOOL CICFRangerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	for (std::vector< std::pair< NETCON_PROPERTIES *, INetSharingConfiguration * > >::iterator pPair = m_pConnections->begin(); pPair != m_pConnections->end(); pPair++)
	{
		int nIdx = m_ctrlListConnections.AddString(pPair->first->pszwName);

		if (0 <= nIdx)
		{
			m_ctrlListConnections.SetItemDataPtr(nIdx, pPair->second);
		}
	}

	m_ctrlListConnections.SetCurSel(0);

	m_ctrlEditComputer.SetWindowText(L"127.0.0.1");

	m_ctrlRadioButtonTCP.SetCheck(1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CICFRangerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CICFRangerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CICFRangerDlg::OnEnChangeEditExtStart()
{
	rangeChange();
}

void CICFRangerDlg::OnEnChangeEditExtEnd()
{
	rangeChange();
}

void CICFRangerDlg::OnEnChangeEditIntStart()
{
	rangeChange();
}

void CICFRangerDlg::rangeChange()
{
	CString csTemp;

	m_ctrlEditExtStart.GetWindowText(csTemp);
	int nExtStart = _wtoi(csTemp);

	m_ctrlEditExtEnd.GetWindowText(csTemp);
	int nExtEnd = _wtoi(csTemp);

	m_ctrlEditIntStart.GetWindowText(csTemp);
	int nIntStart = _wtoi(csTemp);

	csTemp.Empty();

	if (0 < nExtStart && 0 < nExtEnd && nExtStart <= nExtEnd && 0 < nIntStart)
	{
		int nIntEnd = nIntStart + (nExtEnd - nExtStart);
		csTemp.Format(L"%d", nIntEnd);
	}

	m_ctrlEditIntEnd.SetWindowText(csTemp);
}

void CICFRangerDlg::OnBnClickedButton1()
{
	int nIdxConnection = m_ctrlListConnections.GetCurSel();

	CString csDescription;
	m_ctrlEditDescription.GetWindowText(csDescription);
	csDescription.Trim();

	CString csComputer;
	m_ctrlEditComputer.GetWindowText(csComputer);
	csComputer.Trim();

	CString csTemp;

	m_ctrlEditExtStart.GetWindowText(csTemp);
	int nExtStart = _wtoi(csTemp);

	m_ctrlEditExtEnd.GetWindowText(csTemp);
	int nExtEnd = _wtoi(csTemp);

	m_ctrlEditIntStart.GetWindowText(csTemp);
	int nIntStart = _wtoi(csTemp);

	int nIntEnd = nIntStart + (nExtEnd - nExtStart);

	bool bTCP = m_ctrlRadioButtonTCP.GetCheck() == 1;
	bool bUDP = m_ctrlRadioButtonUDP.GetCheck() == 1;

	if (0 > nIdxConnection)
	{
		AfxMessageBox(L"Please select a network connection", MB_OK|MB_ICONWARNING);
	}
	else if (csDescription.IsEmpty())
	{
		AfxMessageBox(L"Please provide a service description", MB_OK|MB_ICONWARNING);
	}
	else if (csComputer.IsEmpty())
	{
		AfxMessageBox(L"Please provide a computer name or IP address", MB_OK|MB_ICONWARNING);
	}
	else if (0 >= nExtStart || 0 >= nExtEnd || nExtStart > nExtEnd)
	{
		AfxMessageBox(L"External Port range is invalid", MB_OK|MB_ICONWARNING);
	}
	else if (0 >= nIntStart)
	{
		AfxMessageBox(L"Internal Port range is invalid", MB_OK|MB_ICONWARNING);
	}
	else if ((bTCP && bUDP) || !(bTCP || bUDP))
	{
		AfxMessageBox(L"Please select either TCP or UDP", MB_OK|MB_ICONWARNING);
	}
	else
	{
		bool bIP = isIpAddress(csComputer);

		int nPorts = (nExtEnd - nExtStart) + 1;
		WCHAR *szS = (1 == nPorts) ? L"" : L"s";

		csTemp.Format(L"This will add %d port%s. Are you sure?", nPorts, szS);

		INetSharingConfiguration *pNSC = reinterpret_cast<INetSharingConfiguration *>(m_ctrlListConnections.GetItemDataPtr(nIdxConnection));

		if (NULL != pNSC && IDYES == AfxMessageBox(csTemp, MB_YESNO|MB_ICONQUESTION))
		{
			m_ctrlProgressAdding.SetPos(0);
			m_ctrlProgressAdding.SetRange32(0, nPorts);

			bool bSuccess = true;

			BSTR bsComputer = csComputer.AllocSysString();

			for (int i = 0; bSuccess && i < nPorts; i++)
			{
				int nIntPort = nIntStart + i;
				int nExtPort = nExtStart + i;

				CString csDescService;
				csDescService.Format(L"%s: %d/%d", LPCTSTR(csDescription), nIntPort, nExtPort);

				INetSharingPortMapping * pNSPM = NULL;

				BSTR bsDescService = csDescService.AllocSysString();

				if (FAILED(pNSC->AddPortMapping(bsDescService, bTCP ? NAT_PROTOCOL_TCP : NAT_PROTOCOL_UDP, nExtPort, nIntPort, 0,
									bsComputer, bIP ? ICSTT_IPADDRESS : ICSTT_NAME, &pNSPM))
				||	NULL == pNSPM)
				{
					CString csErr;
					csErr.Format(L"Error adding %s.\n\nAborting.", LPCTSTR(csDescService));

					AfxMessageBox(csErr, MB_OK|MB_ICONERROR);

					bSuccess = false;
				}
				else
				{
					pNSPM->Enable();
				}

				::SysFreeString(bsDescService);

				pNSPM->Release();

				m_ctrlProgressAdding.SetPos(i+1);
			}

			::SysFreeString(bsComputer);

			if (bSuccess)
			{
				AfxMessageBox(L"Done. You may need to reconnect for changes to take effect.", MB_OK);
			}
		}
	}
}

bool CICFRangerDlg::isIpAddress(const CString &csComputer)
{
	bool bResult = true;

	std::wstring sComputer(csComputer);

	if (std::wstring::npos != sComputer.find_first_not_of(L"0123456789."))
	{
		bResult = false;
	}
	else
	{
		// Blah, CBA doing better validation. Why the FUCK doesn't Windows do this itself?
		// IPv6 users are out of luck, too.
	}

	return(bResult);
}
